#include "SAE.h"

void menu(VilleIUT *tiut[], int *nbIUT, Etudiant *tetud[], int *nbCandidats)
{
    int choix;
    bool c = false;
    while (c == false)
    {
        // system("clear");
        printf("\n\nVeuillez choisir votre menu :\n");
        printf("\t1 - Menu utilisateur\n");
        printf("\t2 - Menu administrateur\n");
        printf("\t3 - menuResponsableDepartement\n");
        printf("\t9 - Quitter\n");
        printf("\nEntrez votre choix :\n> ");
        scanf("%d", &choix);
        switch (choix)
        {
        case 1:
            menuUtilisateur(tiut, nbIUT, tetud, nbCandidats);
            break;
        case 2:
            menuAdministrateur(tiut, nbIUT, tetud, nbCandidats);
            break;
        case 3:
            menuResponsableDepartement(tetud);
            break;
        case 9:
            c = true;
            return;
        default:
            printf("Option non reconnue. Veuillez recommencer.\n");
            break;
        }
    }
}

void menuUtilisateur(VilleIUT *tiut[], int *nbIUT, Etudiant *tetud[], int *nbCandidats)
{
    int choix;
    bool c = false;
    while (c == false)
    {
        // system("clear");
        printf("\n\nMenu d'utilisateur : Que voulez-vous faire ?\n");
        printf("\t1 - Voir les villes possédant un IUT\n");
        printf("\t2 - Voir les départements dans chaque IUT\n");
        printf("\t3 - Voir le nombre de places en première année\n");
        printf("\t4 - Voir les IUT possédant un département particulier\n");
        printf("\t9 - Quitter\n");
        printf("\nEntrez votre choix :\n> ");
        scanf("%d", &choix);
        switch (choix)
        {
        case 1:
            affichageVillesIUT(tiut, *nbIUT);
            break;
        case 2:
            affichageDeptIUT(tiut, *nbIUT);
            break;
        case 3:
            affichageNbP(tiut, *nbIUT);
            break;
        case 4:
            affichageDeptParticulier(tiut, *nbIUT);
            break;
        case 9:
            c = true;
            return;
        default:
            printf("Option non reconnue. Veuillez recommencer.\n");
            break;
        }
    }
}

void menuAdministrateur(VilleIUT *tiut[], int *nbIUT, Etudiant *tetud[], int *nbCandidats)
{
    int choix;
    bool c = false;
    while (c == false)
    {
        // system("clear");
        printf("\n\nMenu d'administrateur : Que voulez-vous faire ?\n");
        printf("\t1 - Modifier le nombre de places dans un département\n");
        printf("\t2 - Créer un département dans un IUT\n");
        printf("\t3 - Supprimer un département d'un IUT\n");
        printf("\t4 - Modifier le responsable d'un département\n");
        printf("\t5 - Afficher les informations de tous les candidats\n");
        printf("\t6 - Afficher les informations d'un seul candidat\n");
        printf("\t7 - Lancer la phase de candidature\n");
        printf("\t8 - Stopper la phase de candidature\n");
        printf("\t9 - Quitter\n");
        printf("\nEntrez votre choix :\n> ");
        scanf("%d", &choix);
        switch (choix)
        {
        case 1:
            modificationNbPDept(tiut, *nbIUT);
            break;
        case 2:
            creationDept(tiut, *nbIUT);
            break;
        case 3:
            *nbIUT = suppressionDept(tiut, *nbIUT);
            break;
        case 4:
            modificationRespDept(tiut, *nbIUT);
            break;
        case 5:
            afficherCandidats(tetud, *nbCandidats);
            break;
        case 6:
            afficherCandidat(tetud, *nbCandidats);
            break;
        case 7:
            //
            break;
        case 9:
            c = true;
            return;
        default:
            printf("Option non reconnue. Veuillez recommencer.\n");
            break;
        }
    }
}

void menuResponsableDepartement(Etudiant *tetud[])
{
    int choix, nbCandidats;
    bool c = false;
    nbCandidats = chargerCandidats(tetud); 
    moyenneCandidats(tetud, nbCandidats);
    //! Ajouter la moyenne et nommer deux liste pour dmis et en attente
    while (c == false)
    {
        // system("clear");
        printf("\n\nMenu des Responsable de Departement : Que voulez-vous faire ?\n");
        printf("\t1 - Modifier le nombre de places dans un département\n");
        printf("\t2 - Afficher les candidats admis du departement\n");
        printf("\t3 - Afficher les candidats refusés du departement\n");
        printf("\t4 - Afficher les candidats en attente du departement\n");
        printf("\t5 - Afficher les informations de tous les candidats du departement\n");
        printf("\t6 - Afficher les informations d'un seul candidat du departement\n");
        printf("\t7 - Afficher le statue d'un candidats du departement\n");
        printf("\t8 - Afficher le nombre de candidats admis du departement\n");
        printf("\t9 - Afficher le nombre de candidats refusés du departement\n");
        printf("\t10- Afficher le nombre de candidats en attente du departement\n");
        printf("\t11- Modifier la note minimal d'admission du departement\n");
        printf("\t12- Modifier la note exellente d'admission du departement\n");
        printf("\t13- Quitter\n");
        printf("\nEntrez votre choix :\n> ");
        scanf("%d", &choix);
        switch (choix)
        {
        case 1:
            // modifNbPlaces(nbPlaces)
            break;
        case 2:
            afficherCandidatsAdmis(tetud, nbCandidats);
            break;
        case 3:
            afficherCandidatsRefuses(tetud, nbCandidats);
            break;
        case 4:
            afficherCandidatsAttente(tetud, nbCandidats);
            break;
        case 5:
            afficherCandidats(tetud, nbCandidats);
            break;
        case 6:
            afficherCandidat(tetud, nbCandidats);
            break;
        case 7:
            statueCandidat(tetud, nbCandidats);
            break;
        case 8:
            nbCandidatsAdmis(tetud, nbCandidats);
            break;
        case 9:
            nbCandidatsRefuses(tetud, nbCandidats);
            break;
        case 10:
            nbCandidatsAttente(tetud, nbCandidats);
            break;
        case 11:
            // modifNoteMin(noteMin);
            break;
        case 12:
            // modifNoteExel(noteExel);
            break;
        case 13:
            c = true;
            return;
        default:
            printf("Option non reconnue. Veuillez recommencer.\n");
            break;
        }
    }
}